leetcode 1631.最小体力消耗路径

思路:BFS+二分

这道题和洛谷上的那个"汽车拉力赛"那道题很相似,但是这道题相较于洛谷那个来说会简单一些。

这里作者一开始写的时候思路堵在了怎么在BFS中用二分,先入为主的以为需要先写出来搜索函数然后再去处理二分的事,但是这里是先二分找数,然后再搜索才是对的。所以先入为主之后就没有做出来。

注意:需要注意数据范围,另外,每一次更新mid数值的时候,我们上一次已经搜索过的数组,队列等存储单元都需要清空,不然的话会影响后面的输出结果。还有,二分注意用哪一个模板,选择也是很重要的。这里主要是求最小值,所以是(left+right)/2而不是(left+right+1)/2,还有就是while中不要left<=right,你用范围的二分查找会造成死循环,但是用于基本的找数是可以的。

复制代码
class Solution {
public:
    int minimumEffortPath(vector<vector<int>>& heights) {
        int dx[4]={1,-1,0,0};
        int dy[4]={0,0,1,-1};
        int left=0;
        int right=1000000;
        while(left<right){
            queue<pair<int,int>>q;
            q.push({0,0});
            vector<vector<bool>>st(heights.size(),vector<bool>(heights[0].size(),false));
            st[0][0]=true;
            int mid=(left+right)/2;
        while(!q.empty()){
            auto tmp=q.front();
            q.pop();
            for(int i=0;i<4;i++){
                int a=dx[i]+tmp.first;
                int b=dy[i]+tmp.second;
                if(a>=heights.size()||a<0||b<0||b>=heights[0].size())continue;
                if(st[a][b])continue;
                if(abs(heights[a][b]-heights[tmp.first][tmp.second])>mid)continue;

                q.push({a,b});
                st[a][b]=true;
            }
        }
        if(st[heights.size()-1][heights[0].size()-1])
        {
            right=mid;
        }
        else
        {
            left=mid+1;
        }
        }
        return right;
    }
};
相关推荐
拓恒技术4 小时前
无人机巡检AI算法的工程化落地:从需求到交付的5个核心环节
人工智能·算法·无人机
晨曦中的暮雨4 小时前
限流算法——固定窗口、滑动窗口、漏桶、令牌桶
java·开发语言·算法
怕浪猫4 小时前
Claude Code vs Codex:Computer Use 实现原理深度拆解
算法·面试·github
文丑颜不良啊5 小时前
LeetCode876~900题目解析
java·leetcode
罗西的思考6 小时前
AI 时代的 “房谋杜断”:如何培养能力、品味与判断力
人工智能·算法·机器学习
淡海水6 小时前
07-02-源码-.NET Core GC分配路径
算法·unity·c#·.netcore·gc·1024程序员节
下一站春风里8 小时前
位运算完整学习笔记:按位与(&)+ 异或(^)
开发语言·c++·算法
DRobot8 小时前
【机械制图与CAD实战(二十五)】螺纹的表示方法
算法·机械制图
用户老李8 小时前
卡尔曼滤波自学教程 10:无迹卡尔曼滤波(UKF)
算法
救救孩子把8 小时前
AI面试八股文-23_23-Agent可观测性与生产监控面试题
人工智能·面试·职场和发展·agent·langsmith·langfuase